#include "LDMError.h"
#include <TCFoundation/mystring.h>
#include <TCFoundation/TCStringArray.h>

LDMError::LDMError(LDMErrorType type, char *message, char *filename,
				   char *fileLine, int lineNumber, TCStringArray *extraInfo)
		 :type(type),
		  message(copyString(message)),
		  filename(copyString(filename)),
		  fileLine(copyString(fileLine)),
		  lineNumber(lineNumber),
		  extraInfo(extraInfo)
{
#ifdef _LEAK_DEBUG
	strcpy(className, "LDMError");
#endif
	if (extraInfo)
	{
		extraInfo->retain();
	}
}

LDMError::~LDMError(void)
{
}

void LDMError::dealloc(void)
{
	delete message;
	delete filename;
	delete fileLine;
	if (extraInfo)
	{
		extraInfo->release();
	}
	TCObject::dealloc();
}
