#ifndef __LDMERROR_H__
#define __LDMERROR_H__

#include <TCFoundation/TCObject.h>
#include <stdlib.h>

class TCStringArray;

typedef enum
{
	LDMEParse,
	LDMEFileNotFound,
	LDMEPartDeterminant,
	LDMEConcaveQuad,
	LDMEConcaveQuadSplit,
	LDMEOpenGL,
	LDMEColor,
	LDMEColinear
} LDMErrorType;

class LDMError: public TCObject
{
	public:
		LDMError(LDMErrorType type, char *message, char *filename,
			char *fileLine, int lineNumber, TCStringArray *extraInfo = NULL);
		LDMErrorType getType(void) { return type; }
		char *getMessage(void) { return message; }
		char *getFilename(void) { return filename; }
		char *getFileLine(void) { return fileLine; }
		int getLineNumber(void) { return lineNumber; }
		TCStringArray *getExtraInfo(void) { return extraInfo; }
	protected:
		virtual ~LDMError(void);
		virtual void dealloc(void);

		LDMErrorType type;
		char *message;
		char *filename;
		char *fileLine;
		int lineNumber;
		TCStringArray *extraInfo;
};

#endif // __LDMERROR_H__
