#include "LDrawSubModel.h"
#include "LDrawModel.h"
#include <string.h>

LDrawSubModel::LDrawSubModel(void)
	:model(NULL)
{
#ifdef _LEAK_DEBUG
	strcpy(className, "LDrawSubModel");
#endif
}

LDrawSubModel::~LDrawSubModel(void)
{
}

void LDrawSubModel::dealloc(void)
{
	if (model)
	{
		model->release();
	}
	TCObject::dealloc();
}

void LDrawSubModel::setModel(LDrawModel *value)
{
	value->retain();
	if (model)
	{
		model->release();
	}
	model = value;
}

void LDrawSubModel::setTransformationMatrix(float *value)
{
	memcpy(transformationMatrix, value, 16 * sizeof(float));
}

TCObject *LDrawSubModel::copy(void)
{
	LDrawSubModel *newSubModel = new LDrawSubModel;

	newSubModel->model = (LDrawModel*)(model->copy());
	newSubModel->setTransformationMatrix(transformationMatrix);
	newSubModel->color = color;
	newSubModel->colorNumber = colorNumber;
	return newSubModel;
}
