#ifndef __TGLCAMERA_H__
#define __TGLCAMERA_H__

#include <LDLib/TGLFacing.h>

class TGLCamera
{
	public:
		TGLCamera(void);
		TGLCamera(const TGLCamera& cam) {duplicate(cam);}
		~TGLCamera(void);

		Vector getPosition(void) {return position;}
		void setPosition(const Vector &pos) {position = pos;}
		TGLFacing getFacing(void) {return facing;}
		void setFacing(const TGLFacing &newFacing) { facing = newFacing; }
		char* getName(void) {return name;}
		void setName(char* n);
		TGLCamera& operator=(const TGLCamera& right) {return duplicate(right);}
		void project(const Vector &eyeOffset);
		void rotate(const Vector &rotation);
		void move(const Vector &distance);
	protected:
		TGLCamera& duplicate(const TGLCamera& copyFrom);

		Vector position;
		TGLFacing facing;
		char* name;
};

#endif // __TGLCAMERA_H__
