#ifndef __TGLSTUDLOGO_H__
#define __TGLSTUDLOGO_H__

#include <LDLib/TGLCustomShape.h>
#include <TCFoundation/TCImage.h>

class TGLStudLogo : public TGLCustomShape
{
	public:
		TGLStudLogo(void);
		TGLStudLogo(TGLStudLogo &other);

		virtual TCObject *copy(void);
		virtual void drawPoints(float *matrix);
		virtual void setDisk(const Vector &center, float radius,
			int numSegments);
		virtual void begin(void);
		virtual void end(void);

		static void resetTextureCoords(void);
		static void loadTexture(char *filename);
		static void attachTexture(void);
		static void setTextureStuds(bool value) { textureStuds = value; }
		static bool getTextureStuds(void) { return textureStuds; }
		static void setTextureData(TCByte *data, long length);
		static void setRawTextureData(TCByte *data, long length);
		static void setTextureFilterType(int value)
		{
			textureFilterType = value;
		}
		static int getTextureFilterType(void) { return textureFilterType; }
	protected:
		virtual ~TGLStudLogo(void);
		virtual void dealloc(void);
		virtual void genTextureCoords(void);

		static void loadMipTextures(TCImage *mainImage);

		static TCImageArray *textures;
		static GLuint textureID;
		static bool textureStuds;
		static GLint textureFilterType;
		static Vector *textureCoords;
		static Vector *mirroredTextureCoords;
		static class TGLStudLogoCleanup
		{
		public:
			~TGLStudLogoCleanup(void);
		} studLogoCleanup;
		friend TGLStudLogoCleanup;
};

#endif // __TGLSTUDLOGO_H__
