#ifndef __VECTORKEY_H__
#define __VECTORKEY_H__

#include <LDLib/Vector.h>

class VectorKey
{
public:
	VectorKey(void)
	{
		x = 0;
		y = 0;
		z = 0;
	}
	VectorKey(const Vector &vector)
	{
		float precision = 100.0f;

		x = (long)(vector.get(0) * precision);
		y = (long)(vector.get(1) * precision);
		z = (long)(vector.get(2) * precision);
	}
	VectorKey(const VectorKey &other)
	{
		x = other.x;
		y = other.y;
		z = other.z;
	}
/*
	bool lessThan(const VectorKey &other) const
	{
		if (x < other.x)
		{
			return true;
		}
		else if (x > other.x)
		{
			return false;
		}
		else if (y < other.y)
		{
			return true;
		}
		else if (y > other.y)
		{
			return false;
		}
		else if (z < other.z)
		{
			return true;
		}
		else
		{
			return false;
		}
	}
*/
	int compare(const VectorKey &other) const
	{
		if (x < other.x)
		{
			return -1;
		}
		else if (x > other.x)
		{
			return 1;
		}
		else if (y < other.y)
		{
			return -1;
		}
		else if (y > other.y)
		{
			return 1;
		}
		else if (z < other.z)
		{
			return -1;
		}
		else if (z > other.z)
		{
			return 1;
		}
		else
		{
			return 0;
		}
	}
	VectorKey &operator=(const VectorKey &other)
	{
		x = other.x;
		y = other.y;
		z = other.z;
		return *this;
	}
private:
	long x, y, z;
};

/*
bool operator<(const VectorKey &left, const VectorKey& right)
{
	return left.lessThan(right);
}
*/

#endif // __VECTORKEY_H__
