#include "VectorShapeArrayTree.h"
#include "VectorKey.h"

VectorKey *copyVectorKeyFunc(const VectorKey *vectorKey)
{
	return new VectorKey(*vectorKey);
}

int compareVectorKeyFunc(const VectorKey *left, const VectorKey *right)
{
	return left->compare(*right);
}

VectorShapeArrayTree::VectorShapeArrayTree(void)
	:TCObjectTree((TCTreeCompareKeyFunc)compareVectorKeyFunc,
		(TCTreeCopyKeyFunc)copyVectorKeyFunc),
	caseSensitive(caseSensitive)
{
#ifdef _LEAK_DEBUG
	strcpy(className, "VectorShapeArrayTree");
#endif
}

VectorShapeArrayTree::~VectorShapeArrayTree(void)
{
}

void VectorShapeArrayTree::dealloc(void)
{
	TCObjectTree::dealloc();
}

int VectorShapeArrayTree::setObjectForKey(TGLShapeArray *object,
										  const VectorKey* key)
{
	return TCObjectTree::setObjectForKey(object, key);
}

int VectorShapeArrayTree::setObjectForKey(TCObject *object, const void* key)
{
	return TCObjectTree::setObjectForKey(object, key);
}

TGLShapeArray *VectorShapeArrayTree::objectForKey(const VectorKey* key)
{
	return (TGLShapeArray *)TCObjectTree::objectForKey(key);
}

TCObject *VectorShapeArrayTree::objectForKey(const void *key)
{
	return TCObjectTree::objectForKey(key);
}
