#ifndef __TCVECTOROBJECTTREE_H__
#define __TCVECTOROBJECTTREE_H__

#include <TCFoundation/TCObjectTree.h>
#include <TCFoundation/TCTypedObjectArray.h>

class TGLShape;
class VectorKey;

typedef TCTypedObjectArray<TGLShape> TGLShapeArray;

class TCExport VectorShapeArrayTree : public TCObjectTree
{
public:
	VectorShapeArrayTree(void);
	virtual int setObjectForKey(TGLShapeArray *object, const VectorKey *key);
	TGLShapeArray* objectForKey(const VectorKey *key);
protected:
	virtual ~VectorShapeArrayTree(void);
	virtual void dealloc(void);
	virtual int setObjectForKey(TCObject *object, const void *key);
	TCObject* objectForKey(const void *key);

	bool caseSensitive;
};

#endif // __TCVECTOROBJECTTREE_H__
