#ifndef __LDVEXTENSIONSSETUP_H__
#define __LDVEXTENSIONSSETUP_H__

#include <CUI/CUIOGLWindow.h>
#include <GL/glext.h>
#include <GL/wglext.h>

#ifndef GL_MULTISAMPLE_FILTER_HINT_NV
/* NV_multisample_filter_hint */
#define GL_MULTISAMPLE_FILTER_HINT_NV     0x8534
#endif

class LDVExtensionsSetup : public CUIOGLWindow
{
public:
	static void setup(HINSTANCE hInstance);
	static PFNWGLGETPIXELFORMATATTRIBIVEXTPROC
		getWglGetPixelFormatAttribivARB(void)
	{
		return wglGetPixelFormatAttribivARB;
	}
	static PFNWGLGETPIXELFORMATATTRIBFVEXTPROC
		getWglGetPixelFormatAttribfvARB(void)
	{
		return wglGetPixelFormatAttribfvARB;
	}
	static PFNWGLCHOOSEPIXELFORMATEXTPROC getWglChoosePixelFormatARB(void)
	{
		return wglChoosePixelFormatARB;
	}
	static PFNWGLCREATEPBUFFERARBPROC getWglCreatePbufferARB(void)
	{
		return wglCreatePbufferARB;
	}
	static PFNWGLGETPBUFFERDCARBPROC getWglGetPbufferDCARB(void)
	{
		return wglGetPbufferDCARB;
	}
	static PFNWGLRELEASEPBUFFERDCARBPROC getWglReleasePbufferDCARB(void)
	{
		return wglReleasePbufferDCARB;
	}
	static PFNWGLDESTROYPBUFFERARBPROC getWglDestroyPbufferARB(void)
	{
		return wglDestroyPbufferARB;
	}
	static PFNWGLQUERYPBUFFERARBPROC getWglQueryPbufferARB(void)
	{
		return wglQueryPbufferARB;
	}

	static bool checkForWGLExtension(char* extension);
	static bool checkForExtension(char* extension);
	static bool checkForExtension(char* extensionsString, char* extension);
	static bool haveMultisampleExtension(void);
	static bool havePixelBufferExtension(void);
	static bool haveQuincunxExtension(void);
	static char *getWglExtensions(void) { return wglExtensions; }
	static bool haveStencil(void) { return stencilPresent; }
	static bool haveAlpha(void) { return alphaPresent; }
protected:
	LDVExtensionsSetup(HINSTANCE hInstance);
	virtual ~LDVExtensionsSetup(void);
	virtual BOOL initWindow(void);
	virtual void closeWindow(void);

	static PFNWGLGETPIXELFORMATATTRIBIVEXTPROC wglGetPixelFormatAttribivARB;
	static PFNWGLGETPIXELFORMATATTRIBFVEXTPROC wglGetPixelFormatAttribfvARB;
	static PFNWGLCHOOSEPIXELFORMATEXTPROC wglChoosePixelFormatARB;
	static PFNWGLGETEXTENSIONSSTRINGARBPROC wglGetExtensionsStringARB;
	static PFNWGLCREATEPBUFFERARBPROC wglCreatePbufferARB;
	static PFNWGLGETPBUFFERDCARBPROC wglGetPbufferDCARB;
	static PFNWGLRELEASEPBUFFERDCARBPROC wglReleasePbufferDCARB;
	static PFNWGLDESTROYPBUFFERARBPROC wglDestroyPbufferARB;
	static PFNWGLQUERYPBUFFERARBPROC wglQueryPbufferARB;
	static char *wglExtensions;
	static char *glExtensions;
	static bool performedInitialSetup;
	static bool stencilPresent;
	static bool alphaPresent;

	static class LDVExtensionsSetupCleanup
	{
	public:
		~LDVExtensionsSetupCleanup(void);
	} extensionsSetupCleanup;
	friend LDVExtensionsSetupCleanup;
};

#endif // __LDVEXTENSIONSSETUP_H__