#ifndef __SSCONFIGURE_H__
#define __SSCONFIGURE_H__

#include <CUI/CUIWindow.h>

class LDViewPreferences;

class SSConfigure: public CUIWindow
{
public:
	SSConfigure(HINSTANCE);
	virtual void run(void);
	static char* defaultFilename(void);
	static void clearGlocalSSConfigure(void) { globalSSConfigure = NULL; }
protected:
	virtual void dealloc(void);
	void createConfigureWindow(void);
	void setupPropSheet(void);
	void addPropSheetPage(int resourceId, char* title);
	void createPropSheet(void);
	UINT propSheetPageProc(HWND hwnd, UINT uMsg, LPPROPSHEETPAGE ppsp);
	void setupSSPage(void);
	void setupLDViewPage(void);
	BOOL dialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
	BOOL doDialogNotify(HWND hDlg, int controlId, LPNMHDR notification);
	void setupSlider(int controlId, short min, short max, WORD frequency,
		int value);
	BOOL doDialogCommand(HWND hDlg, int controlId, int notifyCode,
		HWND controlHWnd);
	BOOL doDialogVScroll(HWND hDlg, int scrollCode, int position,
		HWND hScrollBar);
	virtual void applyChanges(void);
	virtual void doBrowse(void);

	static BOOL CALLBACK staticPropDialogProc(HWND hDlg, UINT message,
		WPARAM wParam, LPARAM lParam);
	static UINT CALLBACK staticPropSheetPageProc(HWND hwnd, UINT uMsg,
		LPPROPSHEETPAGE ppsp);
	static int CALLBACK staticPropSheetProc(HWND hDlg, UINT uMsg,
		LPARAM lParam);

	HWND hPropSheet;
	HWND hSSPage;
	HWND hLDViewPage;
	PROPSHEETPAGE propSheetPages[2];
	HPROPSHEETPAGE propSheetPageHandles[2];
	int numPropSheetPages;
	LDViewPreferences *prefs;
	BOOL initializingPrefs;

	static SSConfigure *globalSSConfigure;
};

#endif __SSCONFIGURE_H__
