#ifndef __TCSTRINGARRAY_H__
#define __TCSTRINGARRAY_H__

#include <TCFoundation/TCArray.h>

#if defined(__APPLE__)
#	define stricmp strcasecmp
#endif

class TCExport TCStringArray : public TCArray
{
	public:
		TCStringArray(unsigned int = 0, int = 1);

		virtual int addString(const char*);
		virtual void insertString(const char*, unsigned int = 0);
		virtual int replaceString(const char*, unsigned int);
		virtual int appendString(const char*, unsigned int);
		virtual int indexOfString(const char*);
		virtual int removeString(const char*);
		virtual int removeString(int);
		virtual void removeAll(void);
		virtual char* stringAtIndex(unsigned int);
		virtual char* operator[](unsigned int);
		virtual int readFile(const char*);
		int isCaseSensitive(void) { return caseSensitive; }
		virtual TCObject *copy(void);
	protected:
		virtual ~TCStringArray(void);
		virtual void dealloc(void);
		virtual void copyContents(TCStringArray *otherStringArray);

		int caseSensitive;
};

#endif // __TCSTRINGARRAY_H__
